<template>
  <div class="panel">
    <h1>Procesar plantilla</h1>
    <p class="mt-4">
      Haz una fotografía o escanea la plantilla sobre la que has trabajado y
      súbela como una imagen <span class="font-bold">JPEG</span>.
    </p>
    <img :src="previewImage" class="uploading-image max-w-xs mx-auto" />
    <input
      class="my-6"
      ref="file"
      type="file"
      accept="image/jpeg"
      @change="refresImage"
    />

    <div class="flex flex-row mt-4">
      <label class="mr-4">FPS:</label>
      <Slider class="flex-auto mt-4" v-model="fps" :min="1" :max="50" />
    </div>
    <div class="text-sm text-gray-600">
      Imágenes por segundo a la que se reproducirá el gif
    </div>

    <div
      class="
        mt-4
        bg-red-300
        p-6
        font-bold
        text-red-900
        border-red-400 border-2
        rounded-lg
      "
      v-if="errorMessage"
    >
      {{ errorMessage }}
    </div>

    <button
      @click="uploadImage"
      class="
        mt-4
        px-4
        py-2
        bg-green-300
        hover:bg-green-500
        hover:text-gray-100
        rounded-lg
      "
      :disabled="loading"
      v-if="!loading"
    >
      <span>Procesar imagen</span>
    </button>
    <div v-if="loading" class="mt-4 px-4 py-2 bg-gray-400 rounded-lg">
      Procesando
    </div>

    <div v-if="downloadGif !== null">
      <img :src="downloadGif" class="uploading-image max-w-full mt-10" />
      <div class="mt-4">
        <a
          :href="downloadGif"
          download="gifanimation.gif"
          target="_blank"
          class="
            mt-4
            px-4
            py-2
            bg-green-300
            hover:bg-green-500
            hover:text-gray-100
            rounded-lg
          "
          >Descargar gif</a
        >
      </div>
    </div>
  </div>
</template>

<script>
import axios from "axios";
import Slider from "@vueform/slider";
import "@vueform/slider/themes/default.css";

export default {
  components: { Slider },
  name: "imageUpload",
  data() {
    return {
      previewImage: null,
      downloadGif: null,
      fps: 4,
      loading: false,
      errorMessage: null,
    };
  },
  methods: {
    refresImage(e) {
      const image = e.target.files[0];
      const reader = new FileReader();
      reader.readAsDataURL(image);
      reader.onload = (e) => {
        this.previewImage = e.target.result;
        // console.log(this.previewImage);
        console.log(e.type);
      };
    },
    uploadImage(e) {
      const URL = "/api/aruco";

      this.downloadGif = null;
      let fileInputElement = this.$refs.file;

      let data = new FormData();
      data.append("fps", this.fps);
      data.append("file", fileInputElement.files[0]);

      let config = {
        responseType: "blob",
        header: {
          "Content-Type": "image/gif",
        },
      };

      this.errorMessage = null;
      this.loading = true;

      axios
        .post(URL, data, config)
        .then((response) => {
          let fileBlob = new Blob([response.data], { type: "image/gif" });
          let fileURL = window.URL.createObjectURL(fileBlob);
          this.downloadGif = fileURL;
          this.loading = false;
        })
        .catch(() => {
          this.errorMessage =
            "Ha habido un problema al procesar el archivo, comprueba que has adjuntado una imagen en formato jpg.";
          this.loading = false;
        });
    },
  },
}; // missing closure added
</script>

<style>
</style>